////////////////////////////////////////////////////////////////////////////////
///
///    Title       : Resource File Accessor
///
///    Copyright (c) 2006, NHN Co., Ltd. ALL RIGHTS RESERVED
///
///    Team        : Desktop Service Development
///	   Author	   : samtree
///	   Last-Update : 2006-12-27
///
////////////////////////////////////////////////////////////////////////////////
#pragma once

#include "NPFile.h"
#include <atlstr.h>

/**
* @group            PCM Base Lib     
* @brief            resource file accessor 
* @date             12/27/2006
* @author           samtree
* @remark          
*/
class CNPResourceFile : public INPFile
{
public:
	virtual BOOL		Open( LPCTSTR lpszURL, DWORD dwFlags = 0 );
	virtual void		Close();
	virtual DWORD		Read( void* lpBuf, DWORD dwCount = 0 );
	virtual BOOL		Write( const void* lpBuf, DWORD dwCount ) { (lpBuf); (dwCount); return FALSE; }

	virtual ULONGLONG	GetSize();

protected:
private:
	HINSTANCE	m_hModule;
	HGLOBAL		m_hMem, m_hGlobal;
	CString		m_szFileName, m_szResourceName, m_szType;
	HRSRC		m_hRSrc;
	DWORD		m_dwLen;

public:
	CNPResourceFile( void );
	virtual ~CNPResourceFile( void );
};